package calc;

public class Calculator {
	private static final int MAX_DEPTH = 30;

	public static double evaluate(String expression) {
		return evaluate(0, expression);
	}

	static double evaluate(int i, String expression) {
		if(i > MAX_DEPTH) {
			throw new IllegalStateException();
		}
		log(i, "EVAL: " + expression);
		// TODO: Functions (round, floor, ceil, abs)
		// Parenthesis
		if(expression.contains("(")) {
			return new Parenthesis(i).accept(expression);
		}
		// Exponents
		else if(expression.contains("^")) {
			return new Exponent(i).accept(expression);
		}
		// Mult / Div
		else if(expression.contains("*") || expression.contains("/")) {
			return new MultAndDiv(i).accept(expression);
		}
		// Add / Sub
		else if(expression.contains("+") || expression.indexOf("-") > 0) {
			return new AddAndSub(i).accept(expression);
		}
		// Constants
		else if(expression.matches("^[-]?\\d+(\\.\\d+)?$")) {
			return new Constant(i).accept(expression);
		}
		log(i, "FAIL: " + expression);
		throw new IllegalStateException();
	}

	private static void log(int i, String s) {
		while(i > 0) {
			s = "    " + s; i--;
		}
		System.out.println(s);
	}
}
